﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Data;

namespace notesSample
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
			BindGridToNotes();
		}


		ObservableCollection<Note> notesCollection = new ObservableCollection<Note>();
		private void BindGridToNotes()
		{
			notesCollection.Add(new Note() { FieldName = "field1" });
			notesCollection.Add(new Note() { FieldName = "field2" });
			notesCollection.Add(new Note() { FieldName = "field3" });
			notesCollection.Add(new Note() { FieldName = "field4" });
			notesCollection.Add(new Note() { FieldName = "field5" });

			this.NotesGridView.DataContext = this.notesCollection;
		}

		private void NotesGridView_SelectionChanged(object sender, Telerik.Windows.Controls.SelectionChangeEventArgs e)
		{
			this.FieldNameTextBox.DataContext = NotesGridView.SelectedItem;
		}

		private void FieldNameTextBox_TextChanged(object sender, TextChangedEventArgs e)
		{
			DataRecord selectedRecord = this.NotesGridView.SelectedRecord as DataRecord;
			if (selectedRecord != null)
			{
				Note selectedNote = selectedRecord.Data as Note;
				selectedNote.FieldName = ((TextBox) sender).Text;
			}
		}
	}

	public class Note : DependencyObject
	{
		public static readonly DependencyProperty FieldNameProperty =
	DependencyProperty.Register("FieldName", typeof(string), typeof(Note), new UIPropertyMetadata(null));

		public string FieldName
		{
			get { return (string) GetValue(FieldNameProperty); }
			set { SetValue(FieldNameProperty, value); }
		}
	}
}
